Index: src/binutils/bfd/i386aoutemx.c
===================================================================
RCS file: src/binutils/bfd/i386aoutemx.c
diff -N src/binutils/bfd/i386aoutemx.c
--- nul	1 Jan 1970 00:00:00 -0000
+++ src/binutils/bfd/i386aoutemx.c	6 Jun 2005 02:42:09 -0000	1.7
@@ -0,0 +1,324 @@
+/* BFD back-end for emx a.out binaries, derived from i386aout.c and aout-target.h
+   Copyright 1990, 1991, 1992 Free Software Foundation, Inc.
+
+This file is part of BFD, the Binary File Descriptor library.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#include "sysdep.h"
+#ifdef TRAD_HEADER
+#include TRAD_HEADER
+#endif
+#include "bfd.h"
+
+#ifndef EMX
+#error "EMX TARGET! EMX isn't defined!!!"
+#endif
+
+
+/* Avoid multiple defininitions from aoutx if supporting standarad a.out
+   as well as our own.  */
+/* Do not "beautify" the CONCAT* macro args.  Traditional C will not
+   remove whitespace added here, and thus will fail to concatenate
+   the tokens.  */
+#define NAME(x,y)               CONCAT3(i386aout_emx,_32_,y)
+
+/* previously in hosts/i386emx.h */
+#define DEFAULT_ARCH		bfd_arch_i386
+
+#define MY(OP)			CONCAT2(i386aout_emx_,OP)
+#define TARGETNAME		"a.out-emx"
+
+#define TARGET_PAGE_SIZE	0x1000
+#define TARGET_SEGMENT_SIZE	0x10000
+#define TEXT_START_ADDR		0x10000
+#define TARGET_STACK_END_ADDR	0x80000000
+
+#define HOST_PAGE_SIZE          0x1000
+#define HOST_SEGMENT_SIZE       0x10000
+#define HOST_TEXT_START_ADDR    0x10000
+#define HOST_STACK_END_ADDR     0x80000000
+
+
+#define ZMAGIC_DISK_BLOCK_SIZE	1024
+#define BYTES_IN_WORD		4
+#define NO_CORE_COMMAND
+
+#define NO_WRITE_HEADER_KLUDGE	1
+
+#define N_HEADER_IN_TEXT(x) 0
+
+#define N_TXTOFF(x)	\
+    (N_MAGIC(x) != ZMAGIC ? EXEC_BYTES_SIZE : /* object file or NMAGIC */\
+     N_SHARED_LIB(x) ? 0 : \
+     N_HEADER_IN_TEXT(x) ?	\
+	    EXEC_BYTES_SIZE :			/* no padding */\
+            0x400 + (x).a_hdrofs \
+    )
+
+#define N_DATOFF(x) (N_TXTOFF(x) + N_TXTSIZE(x))
+
+#define IS_STAB(flags) (((flags) & N_STAB) \
+	&& (flags) != (N_IMP1|N_EXT) && (flags) != (N_IMP2|N_EXT) \
+        && ((flags) & ~N_EXT) != N_EXP)
+
+/* end of old hosts/i386emx.h */
+
+
+#include <symcat.h>
+#define MY_object_p                 MY(object_p)
+#define MY_backend_data            &MY(backend_data)
+#define MY_bfd_reloc_type_lookup    i386aout_emx_reloc_type_lookup
+
+#include "libaout.h"
+#include "aout/aout64.h"
+
+static bfd_boolean      MY(set_sizes) PARAMS ((bfd *));
+const bfd_target *      MY(object_p) PARAMS ((bfd *));
+reloc_howto_type *      MY(reloc_type_lookup) PARAMS ((bfd *, bfd_reloc_code_real_type));
+bfd_reloc_status_type   MY(generic_reloc) PARAMS ((bfd *, arelent *, asymbol *, PTR, asection *, bfd *, char **));
+/*reloc_howto_type *  MY(reloc_howto) PARAMS ((bfd *, struct reloc_std_external *, int *, int *, int *));*/
+
+reloc_howto_type MY(howto_table)[] =
+{
+  /* type              rs size bsz  pcrel bitpos ovrf                     sf                name      part_inpl readmask  setmask    pcdone.  */
+HOWTO ( 0,             0,  0,   8,  FALSE, 0, complain_overflow_bitfield, MY(generic_reloc),"8",        TRUE, 0x000000ff,0x000000ff, FALSE),
+HOWTO ( 1,             0,  1,   16, FALSE, 0, complain_overflow_bitfield, MY(generic_reloc),"16",       TRUE, 0x0000ffff,0x0000ffff, FALSE),
+HOWTO ( 2,             0,  2,   32, FALSE, 0, complain_overflow_bitfield, MY(generic_reloc),"32",       TRUE, 0xffffffff,0xffffffff, FALSE),
+HOWTO ( 3,             0,  4,   64, FALSE, 0, complain_overflow_bitfield, MY(generic_reloc),"64",       TRUE, 0xdeaddead,0xdeaddead, FALSE),
+HOWTO ( 4,             0,  0,   8,  TRUE,  0, complain_overflow_signed,   MY(generic_reloc),"DISP8",    TRUE, 0x000000ff,0x000000ff, FALSE),
+HOWTO ( 5,             0,  1,   16, TRUE,  0, complain_overflow_signed,   MY(generic_reloc),"DISP16",   TRUE, 0x0000ffff,0x0000ffff, FALSE),
+HOWTO ( 6,             0,  2,   32, TRUE,  0, complain_overflow_signed,   MY(generic_reloc),"DISP32",   TRUE, 0xffffffff,0xffffffff, FALSE),
+HOWTO ( 7,             0,  4,   64, TRUE,  0, complain_overflow_signed,   MY(generic_reloc),"DISP64",   TRUE, 0xfeedface,0xfeedface, FALSE),
+HOWTO ( 8,             0,  2,    0, FALSE, 0, complain_overflow_bitfield, MY(generic_reloc),"GOT_REL",  FALSE,         0,0x00000000, FALSE),
+HOWTO ( 9,             0,  1,   16, FALSE, 0, complain_overflow_bitfield, MY(generic_reloc),"BASE16",   FALSE,0xffffffff,0xffffffff, FALSE),
+HOWTO (10,             0,  2,   32, FALSE, 0, complain_overflow_bitfield, MY(generic_reloc),"BASE32",   FALSE,0xffffffff,0xffffffff, FALSE),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+  HOWTO (16,	       0,  2,	 0, FALSE, 0, complain_overflow_bitfield, MY(generic_reloc),"JMP_TABLE", FALSE,         0,0x00000000, FALSE),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+  HOWTO (32,	       0,  2,	 0, FALSE, 0, complain_overflow_bitfield, MY(generic_reloc),"RELATIVE",  FALSE,         0,0x00000000, FALSE),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+EMPTY_HOWTO (-1),
+  HOWTO (40,	       0,  2,	 0, FALSE, 0, complain_overflow_bitfield,0,"BASEREL",   FALSE,         0,0x00000000, FALSE),
+};
+
+
+CONST struct aout_backend_data MY(backend_data) = {
+  0,				/* zmagic contiguous */
+  0,				/* text incl header */
+  0,				/* entry is text address */
+  0,				/* exec_hdr_flags */
+  0,				/* text vma? */
+  MY(set_sizes),
+  1,				/* exec header not counted */
+  0,				/* add_dynamic_symbols */
+  0,				/* add_one_symbol */
+  0,				/* link_dynamic_object */
+  0,				/* write_dynamic_symbol */
+  0,				/* check_dynamic_reloc */
+  0				/* finish_dynamic_link */
+};
+
+#define MY_get_section_contents _bfd_generic_get_section_contents
+#include "aoutx.h"
+
+#include "aout-target.h"
+
+#ifndef __EMX__
+
+/* Cross-compilation support, borrowed from EMX C runtime library */
+int _fseek_hdr PARAMS ((FILE *));
+
+int _fseek_hdr (FILE *stream)
+{
+  struct
+    {
+      char magic[2];
+      char fill1[6];
+      unsigned short hdr_size;
+    } exe_hdr;
+  struct
+    {
+      char sig[16];
+      char bound;
+      char fill1;
+      unsigned short hdr_loc_lo;      /* cannot use long, alignment! */
+      unsigned short hdr_loc_hi;
+    } patch;
+  long original_pos;
+  int saved_errno;
+
+  original_pos = ftell (stream);
+  if (fread (&exe_hdr, sizeof (exe_hdr), 1, stream) != 1)
+    goto failure;
+  if (memcmp (exe_hdr.magic, "MZ", 2) != 0)
+    return (fseek (stream, original_pos, SEEK_SET) == -1 ? -1 : 0);
+  if (fseek (stream, original_pos + 16 * exe_hdr.hdr_size, SEEK_SET) == -1)
+    goto failure;
+  if (fread (&patch, sizeof (patch), 1, stream) != 1)
+    goto failure;
+  if (memcmp (patch.sig, "emx", 3) != 0)
+    goto failure;
+  if (fseek (stream, original_pos + patch.hdr_loc_lo
+             + 65536L * patch.hdr_loc_hi, SEEK_SET) == -1)
+    goto failure;
+  return 0;
+
+failure:
+  saved_errno = errno;
+  fseek (stream, original_pos, SEEK_SET);
+  errno = saved_errno;
+  return -1;
+}
+#endif
+
+
+/*
+ * Finish up the reading of an a.out file header
+ */
+const bfd_target *
+MY(object_p) (abfd)
+  bfd *abfd;
+{
+  struct external_exec exec_bytes;	/* Raw exec header from file */
+  struct internal_exec exec;		/* Cleaned-up exec header */
+  const bfd_target *target;
+  size_t org_pos, add;
+
+  org_pos = bfd_tell (abfd);
+  (void)_fseek_hdr(bfd_cache_lookup(abfd));
+  add = bfd_tell (abfd) - org_pos;
+
+  if (bfd_bread ((PTR) &exec_bytes, EXEC_BYTES_SIZE, abfd)
+      != EXEC_BYTES_SIZE)
+  {
+    if (bfd_get_error () != bfd_error_system_call)
+      bfd_set_error (bfd_error_wrong_format);
+    return 0;
+  }
+
+  exec.a_info = bfd_h_get_32 (abfd, exec_bytes.e_info);
+
+  if (N_BADMAG (exec))
+    return 0;
+
+  NAME(aout,swap_exec_header_in)(abfd, &exec_bytes, &exec);
+  exec.a_hdrofs = add;
+  target = NAME(aout,some_aout_object_p) (abfd, &exec, MY(callback));
+  return target;
+}
+
+
+reloc_howto_type *
+MY(reloc_type_lookup) (abfd,code)
+     bfd *abfd;
+     bfd_reloc_code_real_type code;
+{
+#undef STD
+#define STD(i, j)	case i: return &MY(howto_table)[j]
+
+  if (obj_reloc_entry_size (abfd) == RELOC_EXT_SIZE)
+    return NAME(aout,reloc_type_lookup) (abfd, code);
+
+
+  if (code == BFD_RELOC_CTOR)
+    switch (bfd_get_arch_info (abfd)->bits_per_address)
+      {
+      case 32:
+	code = BFD_RELOC_32;
+	break;
+      case 64:
+	code = BFD_RELOC_64;
+	break;
+      }
+
+  /* std relocs.  */
+  switch (code)
+    {
+      STD (BFD_RELOC_8, 0);
+      STD (BFD_RELOC_16, 1);
+      STD (BFD_RELOC_32, 2);
+      STD (BFD_RELOC_8_PCREL, 4);
+      STD (BFD_RELOC_16_PCREL, 5);
+      STD (BFD_RELOC_32_PCREL, 6);
+      STD (BFD_RELOC_16_BASEREL, 9);
+      STD (BFD_RELOC_32_BASEREL, 10);
+    default: return (reloc_howto_type *) NULL;
+    }
+}
+
+/* ELF relocs are against symbols.  If we are producing relocateable
+   output, and the reloc is against an external symbol, and nothing
+   has given us any additional addend, the resulting reloc will also
+   be against the same symbol.  In such a case, we don't want to
+   change anything about the way the reloc is handled, since it will
+   all be done at final link time.  Rather than put special case code
+   into bfd_perform_relocation, all the reloc types use this howto
+   function.  It just short circuits the reloc if producing
+   relocateable output against an external symbol.  */
+
+bfd_reloc_status_type
+MY(generic_reloc) (abfd,
+		   reloc_entry,
+		   symbol,
+		   data,
+		   input_section,
+		   output_bfd,
+		   error_message)
+     bfd *abfd ATTRIBUTE_UNUSED;
+     arelent *reloc_entry;
+     asymbol *symbol;
+     PTR data ATTRIBUTE_UNUSED;
+     asection *input_section;
+     bfd *output_bfd;
+     char **error_message ATTRIBUTE_UNUSED;
+{
+  if (output_bfd != (bfd *) NULL
+      && (symbol->flags & BSF_SECTION_SYM) == 0
+      && (! reloc_entry->howto->partial_inplace
+	  || reloc_entry->addend == 0))
+    {
+      reloc_entry->address += input_section->output_offset;
+      return bfd_reloc_ok;
+    }
+
+  return bfd_reloc_continue;
+}
+
+
+
Index: src/binutils/bfd/libaout.h
===================================================================
RCS file: /gccos2/src/binutils/bfd/libaout.h,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/bfd/libaout.h	16 Aug 2003 16:44:20 -0000	1.1.1.2
+++ src/binutils/bfd/libaout.h	16 Dec 2003 22:01:17 -0000	1.5
@@ -23,6 +23,14 @@
 #ifndef LIBAOUT_H
 #define LIBAOUT_H
 
+/* !! NASTY HACK !! */
+#ifdef __EMX__
+#include "config.h"
+#ifdef TRAD_HEADER
+#include TRAD_HEADER
+#endif
+#endif
+
 /* We try to encapsulate the differences in the various a.out file
    variants in a few routines, and otherwise share large masses of code.
    This means we only have to fix bugs in one place, most of the time.  */
@@ -250,6 +258,15 @@
 struct internal_exec
 {
     long a_info;		/* Magic number and flags, packed */
+#ifdef EMX
+    long a_hdrofs;		/* Offset from file start to a.out header */
+#else
+/** remove me **/
+#ifdef __EMX__
+#error "error EMX is not defined!!!"
+#endif
+/** remove me **/
+#endif
     bfd_vma a_text;		/* length of text, in bytes  */
     bfd_vma a_data;		/* length of data, in bytes  */
     bfd_vma a_bss;		/* length of uninitialized data area in mem */
Index: src/binutils/bfd/syms.c
===================================================================
RCS file: /gccos2/src/binutils/bfd/syms.c,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/bfd/syms.c	16 Aug 2003 16:44:51 -0000	1.1.1.2
+++ src/binutils/bfd/syms.c	6 Jun 2005 02:42:09 -0000	1.4
@@ -288,6 +288,15 @@
 .  {* This symbol is thread local.  Used in ELF.  *}
 .#define BSF_THREAD_LOCAL  0x40000
 .
+.  {* Symbol is an emx export definition.  *}
+.#define BSF_EMX_EXPORT    0x10000000
+.
+.  {* Symbol is an emx import reference.  *}
+.#define BSF_EMX_IMPORT1   0x20000000
+.
+.  {* Symbol is an emx import definition.  *}
+.#define BSF_EMX_IMPORT2   0x40000000
+.
 .  flagword flags;
 .
 .  {* A pointer to the section to which this symbol is
@@ -467,6 +476,11 @@
 	   ((type & BSF_LOCAL)
 	    ? (type & BSF_GLOBAL) ? '!' : 'l'
 	    : (type & BSF_GLOBAL) ? 'g' : ' '),
+#ifdef EMX
+	   (type & BSF_EMX_IMPORT1) ? 'e' :
+	   (type & BSF_EMX_IMPORT2) ? 'E' :
+	   (type & BSF_EMX_EXPORT) ? 'X' :
+#endif /* EMX */
 	   (type & BSF_WEAK) ? 'w' : ' ',
 	   (type & BSF_CONSTRUCTOR) ? 'C' : ' ',
 	   (type & BSF_WARNING) ? 'W' : ' ',
@@ -667,6 +681,14 @@
       else
 	return 'W';
     }
+#ifdef EMX
+  if (symbol->flags & BSF_EMX_IMPORT1)
+    return 'e';
+  if (symbol->flags & BSF_EMX_IMPORT2)
+    return 'E';
+  if (symbol->flags & BSF_EMX_EXPORT)
+    return 'X';
+#endif /* EMX */
   if (!(symbol->flags & (BSF_GLOBAL | BSF_LOCAL)))
     return '?';
 
Index: src/binutils/bfd/sysdep.h
===================================================================
RCS file: /gccos2/src/binutils/bfd/sysdep.h,v
retrieving revision 1.1.1.2
retrieving revision 1.6
diff -w -u -r1.1.1.2 -r1.6
--- src/binutils/bfd/sysdep.h	16 Aug 2003 16:44:51 -0000	1.1.1.2
+++ src/binutils/bfd/sysdep.h	16 Dec 2003 22:01:17 -0000	1.6
@@ -26,6 +26,12 @@
 
 #include "config.h"
 
+#ifdef __EMX__ /* r=bird: hmm seen this before. */
+#ifdef TRAD_HEADER
+#include TRAD_HEADER
+#endif
+#endif /* __EMX__ */
+
 #ifdef HAVE_STDDEF_H
 #include <stddef.h>
 #endif
Index: src/binutils/bfd/targets.c
===================================================================
RCS file: /gccos2/src/binutils/bfd/targets.c,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/bfd/targets.c	16 Aug 2003 16:44:51 -0000	1.1.1.2
+++ src/binutils/bfd/targets.c	25 Sep 2003 19:27:01 -0000	1.4
@@ -629,6 +629,7 @@
 extern const bfd_target i386aout_vec;
 extern const bfd_target i386bsd_vec;
 extern const bfd_target i386coff_vec;
+extern const bfd_target i386aout_emx_vec;
 extern const bfd_target i386dynix_vec;
 extern const bfd_target i386freebsd_vec;
 extern const bfd_target i386linux_vec;
@@ -933,6 +934,7 @@
 	&hp300bsd_vec,
 #endif
 	&hp300hpux_vec,
+	&i386aout_emx_vec,
 	&i386aout_vec,
 	&i386bsd_vec,
 	&i386coff_vec,
Index: src/binutils/bfd/trad-core.c
===================================================================
RCS file: /gccos2/src/binutils/bfd/trad-core.c,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/bfd/trad-core.c	16 Aug 2003 16:44:52 -0000	1.1.1.2
+++ src/binutils/bfd/trad-core.c	25 Sep 2003 19:27:01 -0000	1.5
@@ -50,6 +50,9 @@
 struct trad_core_struct
 {
   asection *data_section;
+#ifdef EMX
+  asection *heap_section;
+#endif /* EMX */
   asection *stack_section;
   asection *reg_section;
   struct user u;
@@ -57,6 +60,9 @@
 
 #define core_upage(bfd) (&((bfd)->tdata.trad_core_data->u))
 #define core_datasec(bfd) ((bfd)->tdata.trad_core_data->data_section)
+#ifdef EMX
+#define core_heapsec(bfd) ((bfd)->tdata.trad_core_data->heap_section)
+#endif /* EMX */
 #define core_stacksec(bfd) ((bfd)->tdata.trad_core_data->stack_section)
 #define core_regsec(bfd) ((bfd)->tdata.trad_core_data->reg_section)
 
@@ -97,6 +103,10 @@
     }
 
   /* Sanity check perhaps??? */
+#ifdef EMX
+  if (u.u_magic != UMAGIC)
+    return 0;
+#else /* !EMX */
   if (u.u_dsize > 0x1000000)	/* Remember, it's in pages...  */
     {
       bfd_set_error (bfd_error_wrong_format);
@@ -145,6 +155,7 @@
       }
 #endif
   }
+#endif /* !EMX */
 
   /* OK, we believe you.  You're a core file (sure, sure).  */
 
@@ -170,11 +181,32 @@
   core_regsec (abfd) = bfd_make_section_anyway (abfd, ".reg");
   if (core_regsec (abfd) == NULL)
     goto fail;
+#ifdef EMX
+  core_heapsec (abfd) = bfd_make_section_anyway (abfd, ".heap");
+  if (core_heapsec (abfd) == NULL)
+    goto fail;
+#endif /* EMX */
+
+  core_stacksec (abfd)->name = ".stack";
+  core_datasec (abfd)->name = ".data";
+#ifdef EMX
+  core_heapsec (abfd)->name = ".heap";
+#endif /* EMX */
+  core_regsec (abfd)->name = ".reg";
 
   core_stacksec (abfd)->flags = SEC_ALLOC + SEC_LOAD + SEC_HAS_CONTENTS;
   core_datasec (abfd)->flags = SEC_ALLOC + SEC_LOAD + SEC_HAS_CONTENTS;
   core_regsec (abfd)->flags = SEC_HAS_CONTENTS;
-
+#ifdef EMX
+  core_heapsec (abfd)->flags = SEC_ALLOC + SEC_LOAD + SEC_HAS_CONTENTS;
+#endif /* EMX */
+
+#ifdef EMX
+  core_datasec (abfd)->_raw_size =  u.u_data_end - u.u_data_base;
+  core_heapsec (abfd)->_raw_size = u.u_heap_brk - u.u_heap_base;
+  core_stacksec (abfd)->_raw_size = u.u_stack_end - u.u_stack_low;
+  core_regsec (abfd)->_raw_size = sizeof (struct user);
+#else /* not EMX */
   core_datasec (abfd)->_raw_size =  NBPG * u.u_dsize
 #ifdef TRAD_CORE_DSIZE_INCLUDES_TSIZE
     - NBPG * u.u_tsize
@@ -182,9 +214,15 @@
       ;
   core_stacksec (abfd)->_raw_size = NBPG * u.u_ssize;
   core_regsec (abfd)->_raw_size = NBPG * UPAGES; /* Larger than sizeof struct u */
+#endif /* not EMX */
 
   /* What a hack... we'd like to steal it from the exec file,
      since the upage does not seem to provide it.  FIXME.  */
+#ifdef EMX
+  core_datasec (abfd)->vma = u.u_data_base;
+  core_heapsec (abfd)->vma = u.u_heap_base;
+  core_stacksec (abfd)->vma = u.u_stack_low;
+#else /* not EMX */
 #ifdef HOST_DATA_START_ADDR
   core_datasec (abfd)->vma = HOST_DATA_START_ADDR;
 #else
@@ -196,6 +234,7 @@
 #else
   core_stacksec (abfd)->vma = HOST_STACK_END_ADDR - (NBPG * u.u_ssize);
 #endif
+#endif /* not EMX */
 
   /* This is tricky.  As the "register section", we give them the entire
      upage and stack.  u.u_ar0 points to where "register 0" is stored.
@@ -213,17 +252,27 @@
      using minor trickery to get around the offset-or-absolute-addr problem.  */
   core_regsec (abfd)->vma = - (bfd_vma) (unsigned long) u.u_ar0;
 
+#ifdef EMX
+  core_datasec (abfd)->filepos = u.u_data_off;
+  core_heapsec (abfd)->filepos = u.u_heap_off;
+  core_stacksec (abfd)->filepos = u.u_stack_off;
+#else /* not EMX */
   core_datasec (abfd)->filepos = NBPG * UPAGES;
   core_stacksec (abfd)->filepos = (NBPG * UPAGES) + NBPG * u.u_dsize
 #ifdef TRAD_CORE_DSIZE_INCLUDES_TSIZE
     - NBPG * u.u_tsize
 #endif
       ;
+#endif /* not EMX */
+
   core_regsec (abfd)->filepos = 0; /* Register segment is the upage */
 
   /* Align to word at least */
   core_stacksec (abfd)->alignment_power = 2;
   core_datasec (abfd)->alignment_power = 2;
+#ifdef EMX
+  core_heapsec (abfd)->alignment_power = 2;
+#endif /* EMX */
   core_regsec (abfd)->alignment_power = 2;
 
   return abfd->xvec;
Index: src/binutils/bfd/doc/Makefile.am
===================================================================
RCS file: /gccos2/src/binutils/bfd/doc/Makefile.am,v
retrieving revision 1.1.1.2
retrieving revision 1.2
diff -w -u -r1.1.1.2 -r1.2
--- src/binutils/bfd/doc/Makefile.am	16 Aug 2003 16:45:13 -0000	1.1.1.2
+++ src/binutils/bfd/doc/Makefile.am	29 Jan 2004 20:24:07 -0000	1.2
@@ -55,7 +55,7 @@
 MKDOC = chew$(EXEEXT_FOR_BUILD)
 
 $(MKDOC): chew.o
-	$(CC_FOR_BUILD) -o $(MKDOC) chew.o $(LOADLIBES) $(LDFLAGS)
+	$(CC_FOR_BUILD) -o $(MKDOC) chew.o $(LOADLIBES) $(LDFLAGS) $(INTLLIBS)
 
 chew.o: chew.c
 	$(CC_FOR_BUILD) -c -I.. -I$(srcdir)/.. -I$(srcdir)/../../include -I$(srcdir)/../../intl -I../../intl $(H_CFLAGS) $(CFLAGS) $(srcdir)/chew.c
Index: src/binutils/bfd/hosts/i386emx.h
===================================================================
RCS file: src/binutils/bfd/hosts/i386emx.h
diff -N src/binutils/bfd/hosts/i386emx.h
--- nul	1 Jan 1970 00:00:00 -0000
+++ src/binutils/bfd/hosts/i386emx.h	6 Jun 2005 02:42:09 -0000	1.6
@@ -0,0 +1,66 @@
+/* Intel ix86 running OS/2 or DOS */
+
+#ifndef __I386EMX__H__
+#define __I386EMX__H__
+
+#define EMX
+
+#define HOST_PAGE_SIZE          0x1000
+#define HOST_SEGMENT_SIZE       0x10000
+#define HOST_TEXT_START_ADDR    0x10000
+#define HOST_STACK_END_ADDR     0x80000000
+
+#ifndef TEXT_START_ADDR /* bird: does this need to be BFD wide? */
+#define TEXT_START_ADDR		0x10000
+#endif
+
+#define NO_CORE_COMMAND
+
+#if 0 /* moved to i386aoutemx.c */
+
+#define DEFAULT_ARCH		bfd_arch_i386
+
+#define TARGET_PAGE_SIZE	0x1000
+#define TARGET_SEGMENT_SIZE	0x10000
+#define TARGET_STACK_END_ADDR	0x80000000
+
+#define ZMAGIC_DISK_BLOCK_SIZE	1024
+#define BYTES_IN_WORD		4
+
+#define MY(OP)			CONCAT2(i386aout_emx_,OP)
+#define TARGETNAME		"a.out-emx"
+#define NO_WRITE_HEADER_KLUDGE	1
+
+#define N_HEADER_IN_TEXT(x) 0
+
+#define N_TXTOFF(x)	\
+    (N_MAGIC(x) != ZMAGIC ? EXEC_BYTES_SIZE : /* object file or NMAGIC */\
+     N_SHARED_LIB(x) ? 0 : \
+     N_HEADER_IN_TEXT(x) ?	\
+	    EXEC_BYTES_SIZE :			/* no padding */\
+            0x400 + (x).a_hdrofs \
+    )
+
+#define N_DATOFF(x) (N_TXTOFF(x) + N_TXTSIZE(x))
+
+#endif /* moved to i386aoutemx.c */
+
+/* a.out executables emx-specific header */
+struct exec                     /* bird: should this be BFD wide or only for the emx target? */
+{
+  unsigned long a_info;		/* Use macros N_MAGIC, etc for access */
+  unsigned a_text;		/* length of text, in bytes */
+  unsigned a_data;		/* length of data, in bytes */
+  unsigned a_bss;		/* length of uninitialized data area for file, in bytes */
+  unsigned a_syms;		/* length of symbol table data in file, in bytes */
+  unsigned a_entry;		/* start address */
+  unsigned a_trsize;		/* length of relocation info for text, in bytes */
+  unsigned a_drsize;		/* length of relocation info for data, in bytes */
+};
+
+ /* bird: should this be BFD wide or only for the emx target? */
+#define IS_STAB(flags) (((flags) & N_STAB) \
+	&& (flags) != (N_IMP1|N_EXT) && (flags) != (N_IMP2|N_EXT) \
+        && ((flags) & ~N_EXT) != N_EXP)
+
+#endif /* __I386EMX__H__ */
Index: src/binutils/bfd/po/Make-in
===================================================================
RCS file: /gccos2/src/binutils/bfd/po/Make-in,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/bfd/po/Make-in	16 Aug 2003 16:45:25 -0000	1.1.1.2
+++ src/binutils/bfd/po/Make-in	30 Jan 2004 16:07:38 -0000	1.3
@@ -30,10 +30,10 @@
 
 CC = @CC@
 GENCAT = @GENCAT@
-GMSGFMT = PATH=../src:$$PATH @GMSGFMT@
+GMSGFMT = PATH="../src@PATH_IFS@$$PATH" @GMSGFMT@
 MSGFMT = @MSGFMT@
-XGETTEXT = PATH=../src:$$PATH @XGETTEXT@
-MSGMERGE = PATH=../src:$$PATH msgmerge
+XGETTEXT = PATH="../src@PATH_IFS@$$PATH" @XGETTEXT@
+MSGMERGE = PATH="../src@PATH_IFS@$$PATH" msgmerge
 
 DEFS = @DEFS@
 CFLAGS = @CFLAGS@
@@ -222,7 +222,7 @@
 
 update-po: Makefile
 	$(MAKE) $(PACKAGE).pot
-	PATH=`pwd`/../src:$$PATH; \
+	PATH="`pwd`/../src@PATH_IFS@$$PATH"; \
 	cd $(srcdir); \
 	catalogs='$(CATALOGS)'; \
 	for cat in $$catalogs; do \
Index: src/binutils/binutils/addr2line.c
===================================================================
RCS file: /gccos2/src/binutils/binutils/addr2line.c,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/binutils/addr2line.c	16 Aug 2003 16:45:31 -0000	1.1.1.2
+++ src/binutils/binutils/addr2line.c	25 Sep 2003 19:27:01 -0000	1.4
@@ -209,11 +209,15 @@
 
 	  if (base_names && filename != NULL)
 	    {
+#if defined (__EMX__)
+              filename = _getname (filename);
+#else
 	      char *h;
 
 	      h = strrchr (filename, '/');
 	      if (h != NULL)
 		filename = h + 1;
+#endif
 	    }
 
 	  printf ("%s:%u\n", filename ? filename : "??", line);
Index: src/binutils/binutils/ar.c
===================================================================
RCS file: /gccos2/src/binutils/binutils/ar.c,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/binutils/ar.c	16 Aug 2003 16:45:32 -0000	1.1.1.2
+++ src/binutils/binutils/ar.c	25 Sep 2003 19:27:01 -0000	1.4
@@ -396,6 +396,10 @@
   bindtextdomain (PACKAGE, LOCALEDIR);
   textdomain (PACKAGE);
 
+#if defined (__EMX__)
+  _wildcard (&argc, &argv);
+  _response (&argc, &argv);
+#endif /* __EMX__ */
   program_name = argv[0];
   xmalloc_set_program_name (program_name);
 
Index: src/binutils/binutils/bucomm.c
===================================================================
RCS file: /gccos2/src/binutils/binutils/bucomm.c,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/binutils/bucomm.c	16 Aug 2003 16:45:34 -0000	1.1.1.2
+++ src/binutils/binutils/bucomm.c	16 Aug 2003 21:33:49 -0000	1.3
@@ -408,7 +408,12 @@
 {
   static char template[] = "stXXXXXX";
   char *tmpname;
+#if defined (__EMX__)
+  char *slash = _getname (filename);
+  slash = (slash == filename) ? NULL : slash - 1;
+#else /* not __EMX__ */
   char *slash = strrchr (filename, '/');
+#endif /* not __EMX__ */
 
 #ifdef HAVE_DOS_BASED_FILE_SYSTEM
   {
Index: src/binutils/binutils/configure.in
===================================================================
RCS file: /gccos2/src/binutils/binutils/configure.in,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/binutils/configure.in	16 Aug 2003 16:45:47 -0000	1.1.1.2
+++ src/binutils/binutils/configure.in	16 Dec 2003 22:25:06 -0000	1.5
@@ -64,7 +64,7 @@
 AC_PROG_YACC
 AM_PROG_LEX
 
-ALL_LINGUAS="fr tr ja es sv da zh_CN"
+ALL_LINGUAS="fr ja es sv da zh_CN"
 CY_GNU_GETTEXT
 
 AM_MAINTAINER_MODE
@@ -290,6 +290,11 @@
 	ia64-*-*)
 	  OBJDUMP_DEFS="$OBJDUMP_DEFS -DSKIP_ZEROES=16"
 	  ;;
+changequote(,)dnl
+        i[3456]86-*-os2*)
+changequote([,])dnl
+	  BUILD_WINDRES='$(WINDRES_PROG)$(EXEEXT)'
+	  ;;
 	esac
     fi
 done
Index: src/binutils/binutils/nm.c
===================================================================
RCS file: /gccos2/src/binutils/binutils/nm.c,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/binutils/nm.c	16 Aug 2003 16:46:03 -0000	1.1.1.2
+++ src/binutils/binutils/nm.c	25 Sep 2003 19:27:01 -0000	1.4
@@ -399,6 +399,10 @@
   bindtextdomain (PACKAGE, LOCALEDIR);
   textdomain (PACKAGE);
 
+#if defined (__EMX__)
+  _wildcard (&argc, &argv);
+  _response (&argc, &argv);
+#endif /* __EMX__ */
   program_name = *argv;
   xmalloc_set_program_name (program_name);
 
Index: src/binutils/binutils/objcopy.c
===================================================================
RCS file: /gccos2/src/binutils/binutils/objcopy.c,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/binutils/objcopy.c	16 Aug 2003 16:46:05 -0000	1.1.1.2
+++ src/binutils/binutils/objcopy.c	16 Aug 2003 21:33:50 -0000	1.3
@@ -1488,8 +1488,13 @@
      const char *output_target;
 {
   bfd *ibfd;
+  char **matching;
   char **obj_matching;
   char **core_matching;
+#ifdef __EMX__
+  /* Check if they're both zero so we know when to use emxbind or not. */
+  int  bothtargetsnull = (input_target == NULL && output_target == NULL);
+#endif
 
   /* To allow us to do "strip *" without dying on the first
      non-object file, failures are nonfatal.  */
@@ -1532,6 +1537,52 @@
 
       if (!bfd_close (ibfd))
 	RETURN_NONFATAL (input_filename);
+
+      #ifdef __EMX__
+      /*
+       * On OS/2 executables are normally pushed thru emxbind.
+       * So, if input and target format was both NULL and this was
+       * an emxbind'ed executable, then redo the emxbinding. We're
+       * a bit careful not to break anything therefore the NULL target
+       * precautions.
+       *
+       * THIS IS A HACK! It's motivation is to skip some trouble
+       * during GCC building.
+       *
+       * We really don't get everything right now, just get the
+       * "strip xgcc.exe" working good enough.
+       */
+      if (bothtargetsnull && status == 0 && !getenv("NO_STRIP_EMXBIND"))
+        {
+          FILE *child;
+          char szCmd[1024];
+          char *psz;
+          sprintf (szCmd, "emxbind.exe -i \"%s\" 2> nul", input_filename);
+          for (psz = szCmd; *psz; psz++)
+              if (*psz == '\\')  *psz = '/';
+          if ((child = popen (szCmd, "r")) != NULL)
+            {
+              if (!pclose (child))
+                {
+                  char *tmpname;
+                  char  tmpnameexe[260];
+
+                  tmpname = make_tempname (output_filename);
+                  if (!tmpname)
+                      RETURN_NONFATAL (input_filename);
+                  strcat(strcpy(tmpnameexe, tmpname), ".exe");
+                  free(tmpname);
+
+                  sprintf(szCmd, "emxbind.exe -bq -o \"%s\" \"%s\"", tmpnameexe, output_filename);
+                  for (psz = szCmd; *psz; psz++)
+                      if (*psz == '\\')  *psz = '/';
+                  if (!system (szCmd))
+                      smart_rename (tmpnameexe, output_filename, preserve_dates);
+                  unlink (tmpnameexe);
+                }
+            }
+        }
+      #endif
     }
   else
     {
Index: src/binutils/binutils/objdump.c
===================================================================
RCS file: /gccos2/src/binutils/binutils/objdump.c,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/binutils/objdump.c	16 Aug 2003 16:46:06 -0000	1.1.1.2
+++ src/binutils/binutils/objdump.c	25 Sep 2003 19:27:01 -0000	1.4
@@ -2618,6 +2618,10 @@
   bindtextdomain (PACKAGE, LOCALEDIR);
   textdomain (PACKAGE);
 
+#if defined (__EMX__)
+  _wildcard (&argc, &argv);
+  _response (&argc, &argv);
+#endif /* __EMX__ */
   program_name = *argv;
   xmalloc_set_program_name (program_name);
 
Index: src/binutils/binutils/rename.c
===================================================================
RCS file: /gccos2/src/binutils/binutils/rename.c,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/binutils/rename.c	16 Aug 2003 16:46:17 -0000	1.1.1.2
+++ src/binutils/binutils/rename.c	16 Aug 2003 21:33:50 -0000	1.3
@@ -156,7 +156,7 @@
 
   exists = lstat (to, &s) == 0;
 
-#if defined (_WIN32) && !defined (__CYGWIN32__)
+#if (defined (_WIN32) && !defined (__CYGWIN32__)) || defined (__OS2__)
   /* Win32, unlike unix, will not erase `to' in `rename(from, to)' but
      fail instead.  Also, chown is not present.  */
 
Index: src/binutils/binutils/size.c
===================================================================
RCS file: /gccos2/src/binutils/binutils/size.c,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/binutils/size.c	16 Aug 2003 16:46:20 -0000	1.1.1.2
+++ src/binutils/binutils/size.c	25 Sep 2003 19:27:01 -0000	1.4
@@ -135,6 +135,10 @@
   bindtextdomain (PACKAGE, LOCALEDIR);
   textdomain (PACKAGE);
 
+#if defined (__EMX__)
+  _wildcard (&argc, &argv);
+  _response (&argc, &argv);
+#endif /* __EMX__ */
   program_name = *argv;
   xmalloc_set_program_name (program_name);
 
